"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EncryptBytesRequest = void 0;

var flatbuffers = _interopRequireWildcard(require("flatbuffers"));

var _entity = require("../model/entity");

var _fileHints = require("../model/file-hints");

var _keyOptions = require("../model/key-options");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class EncryptBytesRequest {
  constructor() {
    _defineProperty(this, "bb", null);

    _defineProperty(this, "bb_pos", 0);
  }

  __init(i, bb) {
    this.bb_pos = i;
    this.bb = bb;
    return this;
  }

  static getRootAsEncryptBytesRequest(bb, obj) {
    return (obj || new EncryptBytesRequest()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
  }

  static getSizePrefixedRootAsEncryptBytesRequest(bb, obj) {
    bb.setPosition(bb.position() + flatbuffers.SIZE_PREFIX_LENGTH);
    return (obj || new EncryptBytesRequest()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
  }

  message(index) {
    const offset = this.bb.__offset(this.bb_pos, 4);

    return offset ? this.bb.readUint8(this.bb.__vector(this.bb_pos + offset) + index) : 0;
  }

  messageLength() {
    const offset = this.bb.__offset(this.bb_pos, 4);

    return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
  }

  messageArray() {
    const offset = this.bb.__offset(this.bb_pos, 4);

    return offset ? new Uint8Array(this.bb.bytes().buffer, this.bb.bytes().byteOffset + this.bb.__vector(this.bb_pos + offset), this.bb.__vector_len(this.bb_pos + offset)) : null;
  }

  publicKey(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 6);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  options(obj) {
    const offset = this.bb.__offset(this.bb_pos, 8);

    return offset ? (obj || new _keyOptions.KeyOptions()).__init(this.bb.__indirect(this.bb_pos + offset), this.bb) : null;
  }

  signed(obj) {
    const offset = this.bb.__offset(this.bb_pos, 10);

    return offset ? (obj || new _entity.Entity()).__init(this.bb.__indirect(this.bb_pos + offset), this.bb) : null;
  }

  fileHints(obj) {
    const offset = this.bb.__offset(this.bb_pos, 12);

    return offset ? (obj || new _fileHints.FileHints()).__init(this.bb.__indirect(this.bb_pos + offset), this.bb) : null;
  }

  static startEncryptBytesRequest(builder) {
    builder.startObject(5);
  }

  static addMessage(builder, messageOffset) {
    builder.addFieldOffset(0, messageOffset, 0);
  }

  static createMessageVector(builder, data) {
    builder.startVector(1, data.length, 1);

    for (let i = data.length - 1; i >= 0; i--) {
      builder.addInt8(data[i]);
    }

    return builder.endVector();
  }

  static startMessageVector(builder, numElems) {
    builder.startVector(1, numElems, 1);
  }

  static addPublicKey(builder, publicKeyOffset) {
    builder.addFieldOffset(1, publicKeyOffset, 0);
  }

  static addOptions(builder, optionsOffset) {
    builder.addFieldOffset(2, optionsOffset, 0);
  }

  static addSigned(builder, signedOffset) {
    builder.addFieldOffset(3, signedOffset, 0);
  }

  static addFileHints(builder, fileHintsOffset) {
    builder.addFieldOffset(4, fileHintsOffset, 0);
  }

  static endEncryptBytesRequest(builder) {
    const offset = builder.endObject();
    return offset;
  }

}

exports.EncryptBytesRequest = EncryptBytesRequest;
//# sourceMappingURL=encrypt-bytes-request.js.map