"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EncryptSymmetricFileRequest = void 0;

var flatbuffers = _interopRequireWildcard(require("flatbuffers"));

var _fileHints = require("../model/file-hints");

var _keyOptions = require("../model/key-options");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class EncryptSymmetricFileRequest {
  constructor() {
    _defineProperty(this, "bb", null);

    _defineProperty(this, "bb_pos", 0);
  }

  __init(i, bb) {
    this.bb_pos = i;
    this.bb = bb;
    return this;
  }

  static getRootAsEncryptSymmetricFileRequest(bb, obj) {
    return (obj || new EncryptSymmetricFileRequest()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
  }

  static getSizePrefixedRootAsEncryptSymmetricFileRequest(bb, obj) {
    bb.setPosition(bb.position() + flatbuffers.SIZE_PREFIX_LENGTH);
    return (obj || new EncryptSymmetricFileRequest()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
  }

  input(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 4);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  output(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 6);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  passphrase(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 8);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  options(obj) {
    const offset = this.bb.__offset(this.bb_pos, 10);

    return offset ? (obj || new _keyOptions.KeyOptions()).__init(this.bb.__indirect(this.bb_pos + offset), this.bb) : null;
  }

  fileHints(obj) {
    const offset = this.bb.__offset(this.bb_pos, 12);

    return offset ? (obj || new _fileHints.FileHints()).__init(this.bb.__indirect(this.bb_pos + offset), this.bb) : null;
  }

  static startEncryptSymmetricFileRequest(builder) {
    builder.startObject(5);
  }

  static addInput(builder, inputOffset) {
    builder.addFieldOffset(0, inputOffset, 0);
  }

  static addOutput(builder, outputOffset) {
    builder.addFieldOffset(1, outputOffset, 0);
  }

  static addPassphrase(builder, passphraseOffset) {
    builder.addFieldOffset(2, passphraseOffset, 0);
  }

  static addOptions(builder, optionsOffset) {
    builder.addFieldOffset(3, optionsOffset, 0);
  }

  static addFileHints(builder, fileHintsOffset) {
    builder.addFieldOffset(4, fileHintsOffset, 0);
  }

  static endEncryptSymmetricFileRequest(builder) {
    const offset = builder.endObject();
    return offset;
  }

}

exports.EncryptSymmetricFileRequest = EncryptSymmetricFileRequest;
//# sourceMappingURL=encrypt-symmetric-file-request.js.map