"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Identity = void 0;

var flatbuffers = _interopRequireWildcard(require("flatbuffers"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class Identity {
  constructor() {
    _defineProperty(this, "bb", null);

    _defineProperty(this, "bb_pos", 0);
  }

  __init(i, bb) {
    this.bb_pos = i;
    this.bb = bb;
    return this;
  }

  static getRootAsIdentity(bb, obj) {
    return (obj || new Identity()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
  }

  static getSizePrefixedRootAsIdentity(bb, obj) {
    bb.setPosition(bb.position() + flatbuffers.SIZE_PREFIX_LENGTH);
    return (obj || new Identity()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
  }

  id(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 4);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  comment(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 6);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  email(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 8);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  name(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 10);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  static startIdentity(builder) {
    builder.startObject(4);
  }

  static addId(builder, idOffset) {
    builder.addFieldOffset(0, idOffset, 0);
  }

  static addComment(builder, commentOffset) {
    builder.addFieldOffset(1, commentOffset, 0);
  }

  static addEmail(builder, emailOffset) {
    builder.addFieldOffset(2, emailOffset, 0);
  }

  static addName(builder, nameOffset) {
    builder.addFieldOffset(3, nameOffset, 0);
  }

  static endIdentity(builder) {
    const offset = builder.endObject();
    return offset;
  }

  static createIdentity(builder, idOffset, commentOffset, emailOffset, nameOffset) {
    Identity.startIdentity(builder);
    Identity.addId(builder, idOffset);
    Identity.addComment(builder, commentOffset);
    Identity.addEmail(builder, emailOffset);
    Identity.addName(builder, nameOffset);
    return Identity.endIdentity(builder);
  }

}

exports.Identity = Identity;
//# sourceMappingURL=identity.js.map