"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrivateKeyMetadata = void 0;

var flatbuffers = _interopRequireWildcard(require("flatbuffers"));

var _identity = require("../model/identity");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class PrivateKeyMetadata {
  constructor() {
    _defineProperty(this, "bb", null);

    _defineProperty(this, "bb_pos", 0);
  }

  __init(i, bb) {
    this.bb_pos = i;
    this.bb = bb;
    return this;
  }

  static getRootAsPrivateKeyMetadata(bb, obj) {
    return (obj || new PrivateKeyMetadata()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
  }

  static getSizePrefixedRootAsPrivateKeyMetadata(bb, obj) {
    bb.setPosition(bb.position() + flatbuffers.SIZE_PREFIX_LENGTH);
    return (obj || new PrivateKeyMetadata()).__init(bb.readInt32(bb.position()) + bb.position(), bb);
  }

  keyId(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 4);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  keyIdShort(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 6);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  creationTime(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 8);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  fingerprint(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 10);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  keyIdNumeric(optionalEncoding) {
    const offset = this.bb.__offset(this.bb_pos, 12);

    return offset ? this.bb.__string(this.bb_pos + offset, optionalEncoding) : null;
  }

  isSubKey() {
    const offset = this.bb.__offset(this.bb_pos, 14);

    return offset ? !!this.bb.readInt8(this.bb_pos + offset) : false;
  }

  mutate_is_sub_key(value) {
    const offset = this.bb.__offset(this.bb_pos, 14);

    if (offset === 0) {
      return false;
    }

    this.bb.writeInt8(this.bb_pos + offset, +value);
    return true;
  }

  encrypted() {
    const offset = this.bb.__offset(this.bb_pos, 16);

    return offset ? !!this.bb.readInt8(this.bb_pos + offset) : false;
  }

  mutate_encrypted(value) {
    const offset = this.bb.__offset(this.bb_pos, 16);

    if (offset === 0) {
      return false;
    }

    this.bb.writeInt8(this.bb_pos + offset, +value);
    return true;
  }

  identities(index, obj) {
    const offset = this.bb.__offset(this.bb_pos, 18);

    return offset ? (obj || new _identity.Identity()).__init(this.bb.__indirect(this.bb.__vector(this.bb_pos + offset) + index * 4), this.bb) : null;
  }

  identitiesLength() {
    const offset = this.bb.__offset(this.bb_pos, 18);

    return offset ? this.bb.__vector_len(this.bb_pos + offset) : 0;
  }

  static startPrivateKeyMetadata(builder) {
    builder.startObject(8);
  }

  static addKeyId(builder, keyIdOffset) {
    builder.addFieldOffset(0, keyIdOffset, 0);
  }

  static addKeyIdShort(builder, keyIdShortOffset) {
    builder.addFieldOffset(1, keyIdShortOffset, 0);
  }

  static addCreationTime(builder, creationTimeOffset) {
    builder.addFieldOffset(2, creationTimeOffset, 0);
  }

  static addFingerprint(builder, fingerprintOffset) {
    builder.addFieldOffset(3, fingerprintOffset, 0);
  }

  static addKeyIdNumeric(builder, keyIdNumericOffset) {
    builder.addFieldOffset(4, keyIdNumericOffset, 0);
  }

  static addIsSubKey(builder, isSubKey) {
    builder.addFieldInt8(5, +isSubKey, +false);
  }

  static addEncrypted(builder, encrypted) {
    builder.addFieldInt8(6, +encrypted, +false);
  }

  static addIdentities(builder, identitiesOffset) {
    builder.addFieldOffset(7, identitiesOffset, 0);
  }

  static createIdentitiesVector(builder, data) {
    builder.startVector(4, data.length, 4);

    for (let i = data.length - 1; i >= 0; i--) {
      builder.addOffset(data[i]);
    }

    return builder.endVector();
  }

  static startIdentitiesVector(builder, numElems) {
    builder.startVector(4, numElems, 4);
  }

  static endPrivateKeyMetadata(builder) {
    const offset = builder.endObject();
    return offset;
  }

  static createPrivateKeyMetadata(builder, keyIdOffset, keyIdShortOffset, creationTimeOffset, fingerprintOffset, keyIdNumericOffset, isSubKey, encrypted, identitiesOffset) {
    PrivateKeyMetadata.startPrivateKeyMetadata(builder);
    PrivateKeyMetadata.addKeyId(builder, keyIdOffset);
    PrivateKeyMetadata.addKeyIdShort(builder, keyIdShortOffset);
    PrivateKeyMetadata.addCreationTime(builder, creationTimeOffset);
    PrivateKeyMetadata.addFingerprint(builder, fingerprintOffset);
    PrivateKeyMetadata.addKeyIdNumeric(builder, keyIdNumericOffset);
    PrivateKeyMetadata.addIsSubKey(builder, isSubKey);
    PrivateKeyMetadata.addEncrypted(builder, encrypted);
    PrivateKeyMetadata.addIdentities(builder, identitiesOffset);
    return PrivateKeyMetadata.endPrivateKeyMetadata(builder);
  }

}

exports.PrivateKeyMetadata = PrivateKeyMetadata;
//# sourceMappingURL=private-key-metadata.js.map