import * as flatbuffers from 'flatbuffers';
/**
 * An Entity represents the components of an OpenPGP key: a primary public key
 * (which must be a signing key), one or more identities claimed by that key,
 * and zero or more subkeys, which may be encryption keys.
 */
export declare class Entity {
    bb: flatbuffers.ByteBuffer | null;
    bb_pos: number;
    __init(i: number, bb: flatbuffers.ByteBuffer): Entity;
    static getRootAsEntity(bb: flatbuffers.ByteBuffer, obj?: Entity): Entity;
    static getSizePrefixedRootAsEntity(bb: flatbuffers.ByteBuffer, obj?: Entity): Entity;
    publicKey(): string | null;
    publicKey(optionalEncoding: flatbuffers.Encoding): string | Uint8Array | null;
    privateKey(): string | null;
    privateKey(optionalEncoding: flatbuffers.Encoding): string | Uint8Array | null;
    passphrase(): string | null;
    passphrase(optionalEncoding: flatbuffers.Encoding): string | Uint8Array | null;
    static startEntity(builder: flatbuffers.Builder): void;
    static addPublicKey(builder: flatbuffers.Builder, publicKeyOffset: flatbuffers.Offset): void;
    static addPrivateKey(builder: flatbuffers.Builder, privateKeyOffset: flatbuffers.Offset): void;
    static addPassphrase(builder: flatbuffers.Builder, passphraseOffset: flatbuffers.Offset): void;
    static endEntity(builder: flatbuffers.Builder): flatbuffers.Offset;
    static createEntity(builder: flatbuffers.Builder, publicKeyOffset: flatbuffers.Offset, privateKeyOffset: flatbuffers.Offset, passphraseOffset: flatbuffers.Offset): flatbuffers.Offset;
}
