import * as flatbuffers from 'flatbuffers';
export declare class FileHints {
    bb: flatbuffers.ByteBuffer | null;
    bb_pos: number;
    __init(i: number, bb: flatbuffers.ByteBuffer): FileHints;
    static getRootAsFileHints(bb: flatbuffers.ByteBuffer, obj?: FileHints): FileHints;
    static getSizePrefixedRootAsFileHints(bb: flatbuffers.ByteBuffer, obj?: FileHints): FileHints;
    /**
     * IsBinary can be set to hint that the contents are binary data.
     */
    isBinary(): boolean;
    mutate_is_binary(value: boolean): boolean;
    /**
     * FileName hints at the name of the file that should be written. It's
     * truncated to 255 bytes if longer. It may be empty to suggest that the
     * file should not be written to disk. It may be equal to "_CONSOLE" to
     * suggest the data should not be written to disk.
     */
    fileName(): string | null;
    fileName(optionalEncoding: flatbuffers.Encoding): string | Uint8Array | null;
    /**
     * ModTime format allowed: RFC3339, contains the modification time of the file, or the zero time if not applicable.
     */
    modTime(): string | null;
    modTime(optionalEncoding: flatbuffers.Encoding): string | Uint8Array | null;
    static startFileHints(builder: flatbuffers.Builder): void;
    static addIsBinary(builder: flatbuffers.Builder, isBinary: boolean): void;
    static addFileName(builder: flatbuffers.Builder, fileNameOffset: flatbuffers.Offset): void;
    static addModTime(builder: flatbuffers.Builder, modTimeOffset: flatbuffers.Offset): void;
    static endFileHints(builder: flatbuffers.Builder): flatbuffers.Offset;
    static createFileHints(builder: flatbuffers.Builder, isBinary: boolean, fileNameOffset: flatbuffers.Offset, modTimeOffset: flatbuffers.Offset): flatbuffers.Offset;
}
